'' *****************************
'' GPS routine Modified By R Sutcliffe
'' to provide waypoint navigation 
'' (c) 2007 Perry James Mole
'' pjm@ridge-communications.ca
'' *****************************

' PVH Comment - Excellent small GPS reader routines.
' $GPRMB  Recommended minimum Waypoint data        ie: $GPRMB,A,0.66,L,003,004,4917.24,N,12309.57,W,001.3,052.5,000.5,V*20
' $GPGGA  GPS Fix Data                             ie: $GPGGA,170834,4124.8963,N,08151.6838,W,1,05,1.5,280.2,M,-34.0,M,,,*75
' $GPXTE  Sub set of GPRMB cross track error data  ie: $GPXTE,A,A,0.67,L,N*6F



CON

  CR = 13                                               ' ASCII <CR>
  LF = 10                                               ' ASCII <LF>
  serXmit   = 0                                         
  serRecv   = 1       
  
VAR  
   long gps_stack[40] 
   byte GPRMBb[80],GPGGAb[80],GPXTEb[40]   
   long GPRMBa[20],GPGGAa[20],GPXTEa[20]   


   byte gps_buff[80],Rx',cksum
   long cog,cptr,ptr,arg,j
   long Null[1]
   
OBJ
  uart :  "FullDuplexSerial_mini"

PUB start : okay

'' Starts uart object (at baud specified) in a cog
'' -- returns false if no cog available

  okay := uart.start(14,10,0,4800)
  return cog := cognew(readNEMA,@gps_stack) + 1 

PUB readNEMA
  Null[0] := 0
 repeat
   longfill(gps_buff,20,0)
   repeat while Rx <>= "$"      ' wait for the $ to insure we are starting with
     Rx := uart.rx              '   a complete NMEA sentence 
   cptr := 0

   repeat while Rx <>= CR       '  continue to collect data until the end of the NMEA sentence 
     Rx := uart.rx              '  get character from Rx Buffer
     if Rx == ","
       gps_buff[cptr++] := 0    '  If "," replace the character with 0
     else
       gps_buff[cptr++] := Rx   '  else save the character   
   
   if gps_buff[2] == "G"             
     if gps_buff[3] == "G"            
       if gps_buff[4] == "A"            
           copy_buffer(@GPGGAb, @GPGGAa)

   if gps_buff[2] == "R"             
     if gps_buff[3] == "M"            
       if gps_buff[4] == "B"           
           copy_buffer(@GPRMBb, @GPRMBa)
                   
   if gps_buff[0] == "X"
    if gps_buff[1] == "T"  
     if gps_buff[2] == "E"
           copy_buffer(@GPXTEb, @GPXTEa)
                
pub copy_buffer ( buffer,args)
         bytemove(buffer,@gps_buff,cptr) '  copy received data to buffer
         ptr := buffer
         arg := 0
         repeat j from 0 to 78           ' build array of pointers
          if byte[ptr] == 0               ' to each
             if byte[ptr+1] == 0           ' record
                long[args][arg] := Null     ' in 
             else                            ' the
                long[args][arg] := ptr+1     ' data buffer
             arg++
          ptr++
          
' now we just need to return the pointer to the desired record
          
pub CTError                          'cross track errror
   return GPRMBa[1]

pub STR                             'bearing to waypiont
   return GPRMBa[2]
      
pub OID
   return GPRMBa[3]                 'waypiont id

pub DID
   return GPRMBa[4]
   
pub DestLat                          'Waypoint Long
   return GPRMBa[5]
   
pub DestLon
   return GPRMBa[6]                  'Waypoint Long

pub Range
   return GPRMBa[9]                  'Distance to Waypoint
      
pub BRG
   return GPRMBa[10]

pub VMG
   return GPRMBa[9]
    
pub GPSaltitude
   return GPGGAa[8]

pub time
   return GPGGAa[0]

pub latitude
   return GPGGAa[1]
    
pub N_S
   return GPGGAa[2]
     
pub longitude
   return GPGGAa[3]
    
pub E_W
   return GPGGAa[4]

pub satellites
   return GPGGAa[6]
    
pub hdop
   return GPGGAa[7]

pub waypoint
    return   
   
'pub vdop
'   return GPGSAa[14] 