'Pilot_v1.spin
{{
Prop Sailpilot, requires the following components in addtion to the Prop Proto board.

H55B compass modulue,
Serial 2 X 16 LCD display,
ADC0832 with channel 0 conected to Wind Vane and Channel 1 conected to the rudder sensor,
HD-35 Motor controller and a GPS capable of auto sending
GPS capable of auto sending NMEA 0183 sentences at 4800 or 9600 baud.
Four Push Buttons for operator of control of the Sailpilot.

Optional off course alarm is provided.
  
The Wind Vane is only required if Apparent Wind Steering Mode is to be used.

Gps is only required if Steering to Waypoint Mode function is to be used.
THE GPS MUST BE 2.3 COMPLIENT TRANSMITTING GPRMB AND GPXTE SENTENCES.

The Rudder Limit must be set if any of the Auto Steer functions are used.
Failure to properly connect the Rudder feedback sensor and setting the correct Rudder Limit
can cause serious damage to the Drive Motor and or Rudder 

The supply to the Motor drive MUST BE FUSED OR FITTED WITH AN APPROPRIATE CICUIT BREAKER. 

Selection of the correct rudder gain and vane damping for the prevailing conditions
are important for the proper steering under auto pilot.

   
}}

CON
      _clkmode        = xtal1 + pll16x
      _xinfreq        = 5_000_000
      cs              =4               'pin 4 on adc  cs        ADC0830 pin assignments cs,clk,di,do.
      clk             =5               'pin 7 on adc  clk       adc pins via 1K resitors to Prop (tempory solutions but works)
      dao             =6               'pin 6 on adc  do
      dai             =7               'pin 5 on adc  di
      dec             = 0              'pin 10 decrement... simple push button
      as              = 1              'pin 9 auto/standby.... simple push button ...  for cal long hold down
      fnx             = 2
      inc             = 3             'pin 8 function button....simple push button
      mux_v           =%011            'select channel 1 mux data .....monitor vane
      mux_r           =%111            'select channel 2 mux data......monitor rudder position
      LCD_BKSPC     = $08                                   ' move cursor left
      LCD_RT        = $09                                   ' move cursor right
      LCD_LF        = $0A                                   ' move cursor down 1 line
      LCD_CLS       = $0C                                   ' clear LCD (follow with 5 ms delay)
  LCD_CR        = $0D                                   ' move pos 0 of next line
  LCD_BL_ON     = $11                                   ' backlight on
  LCD_BL_OFF    = $12                                   ' backlight off
  LCD_OFF       = $15                                   ' LCD off
  LCD_ON1       = $16                                   ' LCD on; cursor off, blink off
  LCD_ON2       = $17                                   ' LCD on; cursor off, blink on
  LCD_ON3       = $18                                   ' LCD on; cursor on, blink off
  LCD_ON4       = $19                                   ' LCD on; cursor on, blink on
  LCD_LINE0     = $80                                   ' move to line 1, column 0
  LCD_LINE1     = $94                                   ' move to line 2, column 0
  LCD_LINE2     = $A8                                   ' move to line 3, column 0
  LCD_LINE3     = $BC                                   ' move to line 4, column 0

obj 
      gps:  "gps_io_miniV2"
      comp: "HM55B Compass Module Asm"
      lcd : "serial_LCD"
      drv : "drive.spin"
      
var
    long stack_1[30]
    long cog
    byte mux_id               'channel select passed to PUB ADC returns "v"
    byte ib                   'incoming data bit from ADC
    byte mode                 'cal, standby, apparent wind steer of steer waypoint supplied by NMEA sentence from NAV center
    byte v[2]                 'v[0]=vane result, v[1]=rudder result 
    byte cx                   'selected push button
    byte r
    byte vd
    byte rg
    byte semID
              
PUB main
  gps.start     
  cog := cognew(adc,@stack_1) + 1 
  lcd.start(15,9600,2)
  r:=10
  vd~
  rg:=20
  cx~
  lcd.putc(lcd_bl_on)
  lcd.putc(lcd_on1)
  semID:=locknew
    repeat
       cx~
       lcd.putc(lcd_cls)
       lcd.str((string("    Standby    ")))
       lcd.putc(lcd_cr)
       lcd.str((string("Select: Manual ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~
           man
       wait    
       cx~    
       lcd.putc(lcd_cls)
       lcd.str((string("    Standby    ")))
       lcd.putc(lcd_cr)  
       lcd.str((string("Select: Compass ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~
           com
       wait    
       cx~    
       lcd.putc(lcd_cls)
       lcd.str((string("    Standby    ")))
       lcd.putc(lcd_cr)  
       lcd.str((string("Select: AP Wind ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~  
           apw
       wait   
       cx~     
       lcd.putc(lcd_cls)
       lcd.str((string("    Standby    ")))
       lcd.putc(lcd_cr)
       lcd.str((string("Select: Waypoint")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~
           wpt
       wait    
       cx~     
       lcd.putc(lcd_cls)
       lcd.str((string("    Standby    ")))
       lcd.putc(lcd_cr)
       lcd.str((string("Select: Gps Data ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~  
           gpd
       wait    
       cx~    
       lcd.putc(lcd_cls)
       lcd.str((string("    Standby    ")))
       lcd.putc(lcd_cr)
       lcd.str((string("  Select: Cal  ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~  
           cal
       wait   

pub adc |y
  dira[4..7]:=%1101  
  repeat
    if mux_id==mux_r                          'toggle mux data
        mux_id:=mux_v
    else
        mux_id:=mux_v       
    y:=0   
    outa[4..5]:=%10                           'set up CS and Clk levels
    !outa[cs]
    repeat 3                                  'Supply ADC mux data
       clkpulse
       outa[dai]:=mux_id
       mux_id:=mux_id>>1                 
    ib:=0
    repeat  9                                 'clock out Adc date 
        clkpulse
        ib:=ina[dao]
       y:= (y << 1) + ib
    if mux_id==mux_v   
      v[0]:=y                                 'save wind vane adc voltage
    else
      v[1]:=y                                 'save rudder feedback voltage 
    if ina[as]==1                             'scan the panel keys
        repeat while ina[as]==1               ' debound by waiting for
        cx:=as                                ' key to settle at open state
    if ina[dec]==1                            ' save active key
        repeat while ina[dec]==1              'scan three keys AS,INC,DEC
        cx:=dec 
    if ina[fnx]==1
        repeat while ina[fnx]==1
        cx:=fnx     
    if ina[fnx]==1
        repeat while ina[fnx]==1
        cx:=fnx     

pri clkpulse                                    'simple clk pulses for adc chip
    pse
    !outa[clk]
    pse
    !outa[clk] 

       
pri pse
    waitcnt(clkfreq/500+cnt)
          
pri wait
    repeat 1000
      pse

          
Pri Stby
    lcd.putc(lcd_cls)
    lcd.str((string("Mode: Standby ")))
    repeat while cx<>fnx
    cx~    
      
      
Pri man |x
    x~ 
    lcd.putc(lcd.cls)
    lcd.str((string("Mode: Manual ")))
    cx~
    repeat  while cx<>fnx
       if x>$0ff
          lcd.putc(lcd.cls)  
          lcd.str((string("Heading ")))    
          'term.dec(comp.theta)
          lcd.str((string(" Degs ")))   
          x~
       ++x
    cx~    
    return     

    
Pri com
    lcd.putc(lcd.cls)
    lcd.str((string("Mode: Compass ")))
    repeat while cx<>fnx
      ' if r<>0                           'No auto steer if rudder not calibrated 
      '   steer(comp.theta)
    cx~     
    return

Pri apw
    lcd.putc(lcd.cls)
    lcd.str((string("Mode: AP Wind ")))
    cx~
    repeat while cx<>fnx
      ' if vd<>0                          'No auto steer if vane not calibrated
       ' if r<>0                          'No auto steer if rudder not calibrated 
        '  steer(v[0]/255)
    cx~      
    return

Pri wpt
    cx~
    lcd.putc(lcd.cls)
    lcd.str((string("Mode: Waypoint ")))
    repeat while cx<>fnx
        if r<>0
           lcd.putc(lcd_cls)                       'No auto steer if rudder not calibrated 
           lcd.str((string("WPID   ")))
           lcd.str(gps.did)
           lcd.str((string("CTE    ")))
           lcd.str(gps.cterror)
           lcd.putc(lcd_cr)
           lcd.str((string("VMG     ")))
           lcd.str(gps.VMG)
           lcd.str((string("BRG     ")))
           lcd.str(gps.BRG)
           if lcd.str(gps.str)=="L"
              drv.fwd
           elseif lcd.str(gps.str)=="R"  
              drv.revs   
          ' drv.hold(rg)
           wait
    cx~      
    return

pri cal
    lcd.putc(lcd_cls)
    lcd.str((string("Mode: Calibration ")))
    repeat while cx<>fnx
         'set rudder limit
        ' calx
    cx~     
    return

pri gpd
    
       lcd.putc(lcd_cls)
       wait
       wait 
       lcd.str((string("Mode:GPS Data")))
       wait
       wait
       cx~
     repeat until not lockset(semid)
     repeat while cx<>fnx  
       lcd.putc(lcd_cls)
       lcd.str((string("Lat   ")))
       outf(gps.latitude)
       lcd.putc(lcd_cr)
       lcd.str((string("Long ")))
       outf(gps.longitude)
       wait
       wait
       lcd.putc(lcd_cls)
       lcd.str((string(" GMT ")))
       outt(gps.time)
       wait
    cx~
    lockclr (semid)   
    return
    

        


pri steer( x) |str
  str:=x
  repeat 180
    if ++x>360
       x~
  if comp.theta < x
     if v[1] < 127+r                   'rudder limit
       drv.fwd
       drv.hold(rg)
  elseif comp.theta > x
     if v[1] > 127-r                    'rudder limit
       drv.revs
       drv.hold(rg)     
            

{{
pri Calx | x
       cx~
       lcd.putc(lsc_cls)
       lcd.str((string("Rudder Gain:")))
       lcd.dec(rg)
       repeat while cx<>as
         if ++x > $fff
          lcd.out($0)
          term.dec(rg)
            x~
         if cx==dec
               --rg
         elseif cx==inc
               ++rg
        cx~       
      cx~    
       term.out($0)  
       term.str((string("Rudder Limit ")))
       term.dec(r)
       repeat while cx<>as
         if ++x > $fff
          term.out($0)
          term.dec(r)
            x~
         if cx==dec
               --r
         elseif cx==inc
               ++r
        cx~       
       cx~    
       term.out($0)  
       term.str((string("Vane Damping ")))
       term.dec(vd)
       repeat while cx<>as
         if ++x > $fff
          term.out($0)
          term.dec(vd)
            x~
         if cx==dec
               --vd
         elseif cx==inc
               ++vd
        cx~       
       cx~     
  }}        
pri outf(strx)|i,k

     i:=strsize(strx)-1
     if i<0
       return
     repeat i-6
       lcd.putc(byte[strx][k++])
       --i
     lcd.putc($20)
     repeat i
        lcd.putc(byte[strx][k++])
        --i

        
pri outt(strx) | i,k
   k~
   if strsize(strx)<6
     return
   repeat 2
    repeat 2
       lcd.putc(byte[strx][k++])
    lcd.putc($20)        
   lcd.putc(byte[strx][k++])       
   lcd.putc(byte[strx][k++]) 
  