'Pilot_v1.spin
{{
Prop Sailpilot, requires the following components in addtion to the Prop Proto board.

H55B compass modulue,
Serial 2 X 16 LCD display,
ADC0832 with channel 0 conected to Wind Vane and Channel 1 conected to the rudder sensor,
HD-35 Motor controller and a GPS capable of auto sending
GPS capable of auto sending NMEA 0183 sentences at 4800 or 9600 baud.
Four Push Buttons for operator of control of the Sailpilot.

Optional off course alarm is provided.
  
The Wind Vane is only required if Apparent Wind Steering Mode is to be used.

Gps is only required if Steering to Waypoint Mode function is to be used.
THE GPS MUST BE 2.3 COMPLIENT TRANSMITTING GPRMB AND GPXTE SENTENCES.

The Rudder Limit must be set if any of the Auto Steer functions are used.
Failure to properly connect the Rudder feedback sensor and setting the correct Rudder Limit
can cause serious damage to the Drive Motor and or Rudder 

The supply to the Motor drive MUST BE FUSED OR FITTED WITH AN APPROPRIATE CICUIT BREAKER. 

Selection of the correct rudder gain and vane damping for the prevailing conditions
are important for the proper steering under auto pilot.

   
}}

CON
      _clkmode        = xtal1 + pll16x
      _xinfreq        = 5_000_000
      cs              =4               'pin 4 on adc  cs        ADC0830 pin assignments cs,clk,di,do.
      clk             =5               'pin 7 on adc  clk       adc pins via 1K resitors to Prop (tempory solutions but works)
      dao             =6               'pin 6 on adc  do
      dai             =7               'pin 5 on adc  di
      dec             = 0              'pin 10 decrement... simple push button
      as              = 1              'pin 9 auto/standby.... simple push button ...  for cal long hold down
      fnx             = 2
      inc             = 3              'pin 8 function button....simple push button
      mux_v           =%011            'select channel 1 mux data .....monitor vane
      mux_r           =%111            'select channel 2 mux data......monitor rudder position
      LCD_BKSPC     = $08              'move cursor left
      LCD_RT        = $09              'move cursor right
      LCD_LF        = $0A              'move cursor down 1 line
      LCD_CLS       = $0C              'clear LCD (follow with 5 ms delay)
      LCD_CR        = $0D              'move pos 0 of next line
      LCD_BL_ON     = $11              'backlight on
      LCD_BL_OFF    = $12              'backlight off
      LCD_OFF       = $15              'LCD off
      LCD_ON1       = $16              'LCD on; cursor off, blink off
      LCD_ON2       = $17              'LCD on; cursor off, blink on
      LCD_ON3       = $18              'LCD on; cursor on, blink off
      LCD_ON4       = $19              'LCD on; cursor on, blink on
      LCD_LINE0     = $80              'move to line 1, column 0
      LCD_LINE1     = $94              'move to line 2, column 0
      LCD_LINE2     = $A8              'move to line 3, column 0
      LCD_LINE3     = $BC              'move to line 4, column 0
      rgm            =$1800
      rlm            =$1801
      vdm            =$1802
      
obj 
      gps         :  "gps_io_miniV2"
      comp        : "HM55B Compass Module Asm"
      lcd         : "serial_LCD"
      drv         : "drive.spin"
      Mem24LC256  : "24LC256 object"
      term        :  "PC_interface"     
var
    long stack_1[30]
    long cog
    byte mux_id               'channel select passed to PUB ADC returns "v"
    byte ib                   'incoming data bit from ADC
    byte v[2]                 'v[0]=vane result, v[1]=rudder result 
    byte cx                   'selected push button
    byte rl                   'rudder limit
    byte vd                   'vane damping
    byte rg                   'rudder gain
    byte semID                'cog lock
    byte blk_flg              'LCD backlight flag

             
PUB main
'  gps.start     
'  cog := cognew(adc,@stack_1) + 1 
  lcd.start(15,9600,2)               
  cx~
  lcd.putc(lcd_on1)
  Mem24LC256.Initialize(29, 28)   
  rg := Mem24LC256.RandomRead(rgm)
  rl := Mem24LC256.RandomRead(rlm)
  vd := Mem24LC256.RandomRead(vdm)    
  semID:=locknew
  comp.start(12,11,13)
  term.start(31,30)
    repeat
       term.dec(comp.theta)
       term.out($20)
       repeat 1000
           waitcnt(clkfreq/1000+cnt)