'Pilot_v1.spin
{{
Prop Sailpilot, requires the following components in addtion to the Prop Proto board.

H55B compass modulue,
Serial 2 X 16 LCD display,
ADC0832 with channel 0 conected to Wind Vane and Channel 1 conected to the rudder sensor,
HD-35 Motor controller and a GPS capable of auto sending
GPS capable of auto sending NMEA 0183 sentences at 4800 or 9600 baud.
Four Push Buttons for operator of control of the Sailpilot.

Optional off course alarm is provided.
  
The Wind Vane is only required if Apparent Wind Steering Mode is to be used.

Gps is only required if Steering to Waypoint Mode function is to be used.
THE GPS MUST BE 2.3 COMPLIENT TRANSMITTING GPRMB AND GPXTE SENTENCES.

The Rudder Limit must be set if any of the Auto Steer functions are used.
Failure to properly connect the Rudder feedback sensor and setting the correct Rudder Limit
can cause serious damage to the Drive Motor and or Rudder 

The supply to the Motor drive MUST BE FUSED OR FITTED WITH AN APPROPRIATE CICUIT BREAKER. 

Selection of the correct rudder gain and vane damping for the prevailing conditions
are important for the proper steering under auto pilot.

   
}}

CON
      _clkmode        = xtal1 + pll16x
      _xinfreq        = 5_000_000
      st            =750              '1.5 mil secs
      sb             =100             '2.0 mil secs
      pt             =100             '1.0 mil secs
      drivePin        =11
      cs              =4               'pin 4 on adc  cs        ADC0830 pin assignments cs,clk,di,do.
      clk             =5               'pin 7 on adc  clk       adc pins via 1K resitors to Prop (tempory solutions but works)
      dao             =6               'pin 6 on adc  do
      dai             =7               'pin 5 on adc  di
      dec             = 0              'pin 10 decrement... simple push button
      as              = 1              'pin 9 auto/standby.... simple push button ...  for cal long hold down
      fnx             = 2
      inc             = 3              'pin 8 function button....simple push button
      mux_v           =%011            'select channel 1 mux data .....monitor vane
      mux_r           =%111            'select channel 2 mux data......monitor rudder position
      LCD_BKSPC     = $08             'move cursor left
      LCD_RT        = $09              'move cursor right
      LCD_LF        = $0A              'move cursor down 1 line
      LCD_CLS       = $0C              'clear LCD (follow with 5 ms delay)
      LCD_CR        = $0D              'move pos 0 of next line
      LCD_BL_ON     = $11              'backlight on
      LCD_BL_OFF    = $12              'backlight off
      LCD_OFF       = $15              'LCD off
      LCD_ON1       = $16              'LCD on; cursor off, blink off
      LCD_ON2       = $17              'LCD on; cursor off, blink on
      LCD_ON3       = $18              'LCD on; cursor on, blink off
      LCD_ON4       = $19              'LCD on; cursor on, blink on
      LCD_LINE0     = $80              'move to line 1, column 0
      LCD_LINE1     = $94              'move to line 2, column 0
      LCD_LINE2     = $A8              'move to line 3, column 0
      LCD_LINE3     = $BC              'move to line 4, column 0
      rgm            =$1900
      rlm            =$1901
      vdm            =$1902
      
obj 
      gps         :  "gps_io_miniV2"
      comp        : "HM55B Compass Module Asm"
      lcd         : "serial_LCD"
      Mem24LC256  : "24LC256 object"
      floatx      :  "float32"
var
    long stack_1[30]
    long  stack_2[20] 
    long cog1
    long cog2
    byte mux_id               'channel select passed to PUB ADC returns "v"
    byte ib                   'incoming data bit from ADC
    byte v[2]                 'v[0]=vane result, v[1]=rudder result 
    byte cx                   'selected push button
    byte rl                   'rudder limit
    byte vd                   'vane damping
    byte rg                   'rudder gain
    byte semID                'cog lock
    byte blk_flg              'LCD backlight flag
    byte ki                   'course
    byte fi                   'steer flag

             
PUB main : okay
  gps.start
  comp.start(12,11,13)     
  cog1 := cognew(adc,@stack_1) + 1 
  lcd.start(15,9600,2)
  okay := cog2 := cognew(steer(@ki,@fi), @Stack_2)
  floatx.start               
  Mem24LC256.Initialize(29, 28)   
  rg := Mem24LC256.RandomRead(rgm)
  rl := Mem24LC256.RandomRead(rlm)
  vd := Mem24LC256.RandomRead(vdm)    
  semID:=locknew
  cx~
  lcd.putc(lcd_on1)
    repeat
       header
       lcd.str((string("Select: Manual ")))
       repeat while cx<>as and cx<>fnx
          if ina[dec]==1 and ina[inc]==1
            if blk_flg==1
                lcd.putc(lcd_bl_on)
                blk_flg~
            else
                lcd.putc(lcd_bl_off)
                 blk_flg:=1    
       if cx==fnx
           cx~
           man
       wait(100)   
       header 
       lcd.str((string("Select: Compass ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~
           com
       wait(100)
       header
       lcd.str((string("Select: AP Wind ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~  
           apw
'       wait(100)   
       header
       lcd.str((string("Select: Waypoint")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~
           wpt
 '      wait(100)    
       header
       lcd.str((string("Select: Gps Data ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~  
           gpd
 '      wait(100)    
       cx~    
       header
       lcd.str((string("  Select: Cal  ")))
       repeat while cx<>as and cx<>fnx
       if cx==fnx
           cx~  
           cal
 '      wait(100)   
      
           
pub adc |y
  dira[4..7]:=%1101  
  repeat
    if mux_id==mux_r                          'toggle mux data
        mux_id:=mux_v
    else
        mux_id:=mux_v       
    y:=0   
    outa[4..5]:=%10                           'set up CS and Clk levels
    !outa[cs]
    repeat 3                                  'Supply ADC mux data
       clkpulse
       outa[dai]:=mux_id
       mux_id:=mux_id>>1                 
    ib:=0
    repeat  9                                 'clock out Adc date 
        clkpulse
        ib:=ina[dao]
       y:= (y << 1) + ib
    if mux_id==mux_v   
      v[0]:=y                                 'save wind vane adc voltage
    else
      v[1]:=y                                 'save rudder feedback voltage 
    if ina[as]==1                             'scan the panel keys
        repeat while ina[as]==1               ' debound by waiting for
        cx:=as                                ' key to settle at open state 
    if ina[fnx]==1
        repeat while ina[fnx]==1
        cx:=fnx

pri clkpulse                                    'simple clk pulses for adc chip
    pse
    !outa[clk]
    pse
    !outa[clk] 

pri header
      cx~    
     lcd.putc(lcd_cls)
     lcd.str((string("    Standby    ")))
     lcd.putc(lcd_cr)
        
pri pse
    waitcnt(clkfreq/500+cnt)
          
pri wait(x)
    repeat x
      pse

          
Pri Stby
    lcd.putc(lcd_cls)
    lcd.str((string("Mode: Standby ")))
    repeat while cx<>fnx
        if ina[dec]==1 and ina[inc]==1
           lcd.putc(lcd_bl_on)
    cx~    
      
      
Pub man |x
    x~ 
    lcd.putc(lcd_cls)
    lcd.str((string("Mode: Manual ")))
    cx~
    repeat  while cx<>fnx
      lcd.putc(lcd_cls)  
      lcd.str((string("Heading ")))  
      decv(comp.heading)
      lcd.str((string(" Degs ")))   
      wait(1000)
    cx~    
    return     

    
Pri com
   repeat while cx<>fnx
      lcd.putc(lcd_cls)
      lcd.str((string("Mode: Compass ")))
      lcd.putc(lcd_cr) 
      if rl<>0
          lcd.str((string("Steering ")))  
          decv(comp.heading)                        
          ki:=comp.heading
      else
           lcd.putc(lcd_cls)
           lcd.str((string("Error no Rudder Limit Set")))
      wait(1000)         
   cx~     
   return

Pri apw
    lcd.putc(lcd.cls)
    lcd.str((string("Mode: AP Wind ")))
    cx~
    repeat while cx<>fnx
         if rl<>0                           'No auto steer if rudder not calibrated 
          '  steer(v[0]/255)  
         else
           lcd.putc(lcd.cls)
           lcd.str((string("Error no Rudder Limit Set"))) 
         wait (1000)
    cx~      
    return

Pri wpt
    lcd.putc(lcd.cls)
    lcd.str((string("Mode: Waypoint ")))
    cx~
    repeat while cx<>fnx
        if rl<>0
           lcd.putc(lcd_cls)                       'No auto steer if rudder not calibrated 
           lcd.str((string("WPID ")))
           lcd.str(gps.did)
           lcd.putc(lcd_cr) 
           lcd.str((string("CTE ")))
           lcd.str(gps.cterror)
           wait(1000)
           lcd.putc(lcd_cls)
           lcd.str((string("DIS ")))
           lcd.str(gps.range)
           lcd.putc(lcd_cr) 
           lcd.str((string("BRG ")))
           lcd.str(gps.BRG)
           fi:=gps.str         'steer port or starboard
        else
           lcd.putc(lcd.cls)
           lcd.str((string("Error no Rudder Limit Set")))           
           wait(1000)
           cx:=fnx
    fi~   
    cx~      
    return

pri cal 
    cx~
    lcd.putc(lcd_cls)
    lcd.str((string("Rudder Limit")))
    repeat while cx<>fnx
         lcd.putc(lcd_cr)
         lcd.putc(LCD_line1)
         lcd.str((string("SET   ")))
         decv(rl)
         if ina[inc]==1 and rl< 50
            rl++
         if ina[dec]==1 and rl > 0
            rl--
         wait(100)
    Mem24LC256.ByteWrite(rlm,rl)            
    cx~
    lcd.putc(lcd_cls)
    lcd.str((string("Rudder Gain")))
    repeat while cx<>fnx
         lcd.putc(lcd_cr)
         lcd.putc(LCD_line1)
         lcd.str((string("SET   ")))
         decv(rg)
         if ina[inc]==1 and rg< 20
            rg++
         if ina[dec]==1 and rg > 5
            rg--
        wait(100)
    Mem24LC256.ByteWrite(rgm,rg)      
    cx~
    lcd.putc(lcd_cls)
    lcd.str((string("Vane Damping")))
    repeat while cx<>fnx
         lcd.putc(lcd_cr)
         lcd.putc(LCD_line1)
         lcd.str((string("SET   ")))
         decv(vd)
         if ina[inc]==1 and vd< 20
            vd++
         if ina[dec]==1 and vd > 5
            vd--
        wait(100)      
    Mem24LC256.ByteWrite(vdm,vd) 

    
pri gpd
    
     lcd.putc(lcd_cls)
     wait(1000) 
     lcd.str((string("Mode:GPS Data")))
     wait(2000)
     cx~
     repeat until not lockset(semid)
     repeat while cx<>fnx  
       lcd.putc(lcd_cls)
       lcd.str((string("Lat   ")))
       outf(gps.latitude)
       lcd.putc(lcd_cr)
       lcd.str((string("Long ")))
       outf(gps.longitude)
       wait(2000)
       lcd.putc(lcd_cls)
       lcd.str((string(" GMT ")))
       outt(gps.time)
       wait(2000)
    cx~  
    lockclr(semid)
    return

Pri decv(value) | i

'' Print a decimal number

  if value < 0
    -value
    lcd.putc($2d)

  i := 1_000_000_000

  repeat 10
    if value => i
      lcd.putc(value / i + "0")
      value //= i
      result~~
    elseif result or i == 1
      lcd.putc("0")
    i /= 10


         
pri outf(strx)|i,k

     i:=strsize(strx)-1
     if i<0
       return
     repeat i-6
       lcd.putc(byte[strx][k++])
       --i
     lcd.putc($20)
     repeat i
        lcd.putc(byte[strx][k++])
        --i

        
pri outt(strx) | i,k
   k~
   if strsize(strx)<6
     return
   repeat 2
    repeat 2
       lcd.putc(byte[strx][k++])
    lcd.putc($20)        
   lcd.putc(byte[strx][k++])       
   lcd.putc(byte[strx][k++]) 
  
pub rlim
  return rl

pub vin
  return v[1]

pub steer(k,f) |str
dira[drivePin]:=1
outa[drivePin]~ 
repeat
  if f=="L"
    if v[1] > 127-rl                     'rudder limit
       port                              'go port
       hold(rg)
  elseif f=="R"
    if v[1] < 127+rl                    'rudder limit
       starboard                        'go starboard
       hold(rg)   
  if f==$0             
      str:=k
      repeat 180
        if ++k>360
            k~
      if comp.heading < k                   
        if v[1] < 127+rl                     'rudder limit
            starboard                        'go starboard
            hold(rg)                         'for period
      elseif comp.heading > k
        if v[1] > 127-rl                      'rudder limit
            port                              'go port
            hold(rg)                          'for period
          
    
pri pulse(d)
    outa[drivePin]:=1
    waitcnt(clkfreq/d+cnt)
    outa[drivePin]~

pub starboard
    pulse(sb)

pri stop
    pulse(st)

pub port
    pulse(pt)

pub hold(h)                               'hold for rudder gain
       repeat (h)
         waitcnt(clkfreq/1000+cnt)
       pulse(st)
              